unit hiMouseParams;

interface

uses Kol, Share, Windows;  

type

  TOnEventAccept = procedure( Sender: PObj; var Accept: Boolean ) of object;
  THIMouseParams = class
   private

   public
    _prop_Speed:integer;
    _prop_DblClickSpeed:integer;
    _prop_MouseTrails:integer;
    _prop_Sonar:byte;
    _prop_WheelScrollChars:integer;
    _prop_WheelScrollLines:integer;
    _prop_SwapButtons:byte;
    _prop_SnapToDefButton:byte;
    _prop_MouseVanish:byte;
    _prop_SaveSettings:byte;
    _prop_Threshold1:integer;
    _prop_Threshold2:integer;
    _prop_Acceleration:integer;    
        
    _data_Speed:THI_Event;
    _data_DblClickSpeed:THI_Event;
    _data_MouseTrails:THI_Event;
    _data_Sonar:THI_Event;
    _data_WheelScrollChars:THI_Event;
    _data_WheelScrollLines:THI_Event;
    _data_SwapButtons:THI_Event;
    _data_SnapToDefButton:THI_Event;
    _data_MouseVanish:THI_Event;        
    _data_SaveSettings:THI_Event;
    _data_Threshold1:THI_Event;    
    _data_Threshold2:THI_Event;
    _data_Acceleration:THI_Event;
    
    procedure _work_doSetSpeed(var _Data:TData; Index:word);
    procedure _work_doSetDblClickSpeed(var _Data:TData; Index:word); 
    procedure _work_doSetMouseTrails(var _Data:TData; Index:word);
    procedure _work_doSetAcceleration(var _Data:TData; Index:word); 
    procedure _work_doSetSonarStatus(var _Data:TData; Index:word); 
    procedure _work_doSetWheelScrollChars(var _Data:TData; Index:word); 
    procedure _work_doSetWheelScrollLines(var _Data:TData; Index:word); 
    procedure _work_doSetSnapToDefButton(var _Data:TData; Index:word);
    procedure _work_doSetVanish(var _Data:TData; Index:word);
    procedure _work_doSwapButtons(var _Data:TData; Index:word);
    
    procedure _var_CurSpeed(var _Data:TData; Index:word);
    procedure _var_CurDblClickSpeed(var _Data:TData; Index:word);
    procedure _var_CurMouseTrails(var _Data:TData; Index:word);
    procedure _var_SonarStatus(var _Data:TData; Index:word);
    procedure _var_CurWheelScrollChars(var _Data:TData; Index:word);
    procedure _var_CurWheelScrollLines(var _Data:TData; Index:word);
    procedure _var_VanishStatus(var _Data:TData; Index:word);
    procedure _var_CurThreshold1(var _Data:TData; Index:word);
    procedure _var_CurThreshold2(var _Data:TData; Index:word);
    procedure _var_CurAcceleration(var _Data:TData; Index:word);       
    procedure _var_IsSnapToDefButton(var _Data:TData; Index:word);
    procedure _var_IsButtonSwapped(var _Data:TData; Index:word);
    procedure _var_IsMousePresent(var _Data:TData; Index:word);
    procedure _var_IsWheelPresent(var _Data:TData; Index:word);
    procedure _var_IsHorizWheelPresent(var _Data:TData; Index:word);
    procedure _var_ButtonsCount(var _Data:TData; Index:word);
    
end;
   
implementation

const SM_MOUSEHORIZONTALWHEELPRESENT = 91; SPI_GETMOUSESONAR = 4124; SPI_SETMOUSESONAR = 4125;
      SPI_GETWHEELSCROLLCHARS = 108; SPI_SETWHEELSCROLLCHARS = 109; SPI_GETMOUSEVANISH = 4128;
      SPI_SETMOUSEVANISH = 4129;

procedure THIMouseParams._work_doSetSpeed;
var iSpeed, ss:integer;
begin
  ss := ReadInteger(_Data, _data_SaveSettings, _prop_SaveSettings);
  if ss <> 0 then ss:= SPIF_UPDATEINIFILE or SPIF_SENDCHANGE;
  iSpeed := ReadInteger(_Data, _data_Speed, _prop_Speed);
  if (iSpeed < 1) or (iSpeed > 20) then iSpeed := 10;
  SystemParametersInfo(SPI_SETMOUSESPEED, 0, Pointer(iSpeed), ss);
end;

procedure THIMouseParams._work_doSetDblClickSpeed;
var iTime, ss:integer;
begin
  ss := ReadInteger(_Data, _data_SaveSettings, _prop_SaveSettings);
  if ss <> 0 then ss:= SPIF_UPDATEINIFILE or SPIF_SENDCHANGE;
  iTime := ReadInteger(_Data, _data_DblClickSpeed, _prop_DblClickSpeed);
  SystemParametersInfo(SPI_SETDOUBLECLICKTIME, iTime, nil, ss);
  //   ,     :
  //SetDoubleClickTime (ReadInteger(_Data, _data_DblClickSpeed, _prop_DblClickSpeed));
end;

procedure THIMouseParams._work_doSetMouseTrails;
var iTrail, ss:integer;
begin
  ss := ReadInteger(_Data, _data_SaveSettings, _prop_SaveSettings);
  if ss <> 0 then ss:= SPIF_UPDATEINIFILE or SPIF_SENDCHANGE;
  iTrail := ReadInteger(_Data, _data_MouseTrails, _prop_MouseTrails);
  SystemParametersInfo(SPI_SETMOUSETRAILS, iTrail, nil, ss);
end;

procedure THIMouseParams._work_doSetAcceleration;
var iaMouse: array[0..2] of integer; ss:integer;
begin
  ss := ReadInteger(_Data, _data_SaveSettings, _prop_SaveSettings);
  if ss <> 0 then ss:= SPIF_UPDATEINIFILE or SPIF_SENDCHANGE;  
  iaMouse[0]:=ReadInteger(_Data, _data_Threshold1, _prop_Threshold1);
  iaMouse[1]:=ReadInteger(_Data, _data_Threshold2, _prop_Threshold2);
  iaMouse[2]:=ReadInteger(_Data, _data_Acceleration, _prop_Acceleration);
  SystemParametersInfo(SPI_SETMOUSE, 0, @iaMouse, ss);
end;

procedure THIMouseParams._work_doSetSonarStatus;
var iStat, ss:integer;
begin
  ss := ReadInteger(_Data, _data_SaveSettings, _prop_SaveSettings);
  if ss <> 0 then ss:= SPIF_UPDATEINIFILE or SPIF_SENDCHANGE;
  iStat := ReadInteger(_Data, _data_Sonar, _prop_Sonar);
  //if iStat <> 0 then iStat := 1;
  SystemParametersInfo(SPI_SETMOUSESONAR, 0, Pointer(iStat), ss);
end;

procedure THIMouseParams._work_doSetWheelScrollChars;
var iCount, ss:integer;
begin
  ss := ReadInteger(_Data, _data_SaveSettings, _prop_SaveSettings);
  if ss <> 0 then ss:= SPIF_UPDATEINIFILE or SPIF_SENDCHANGE;
  iCount := ReadInteger(_Data, _data_WheelScrollChars, _prop_WheelScrollChars);
  SystemParametersInfo(SPI_SETWHEELSCROLLCHARS, iCount, nil, ss);
end;

procedure THIMouseParams._work_doSetWheelScrollLines;
var iCount, ss:integer;
begin
  ss := ReadInteger(_Data, _data_SaveSettings, _prop_SaveSettings);
  if ss <> 0 then ss:= SPIF_UPDATEINIFILE or SPIF_SENDCHANGE;
  iCount := ReadInteger(_Data, _data_WheelScrollLines, _prop_WheelScrollLines);
  SystemParametersInfo(SPI_SETWHEELSCROLLLINES, iCount, nil, ss);
end;

procedure THIMouseParams._work_doSetSnapToDefButton;
var iSnap, ss:integer;
begin
  ss := ReadInteger(_Data, _data_SaveSettings, _prop_SaveSettings);
  if ss <> 0 then ss:= SPIF_UPDATEINIFILE or SPIF_SENDCHANGE;
  iSnap := ReadInteger(_Data, _data_SnapToDefButton, _prop_SnapToDefButton);
  //if iSnap <> 0 then iSnap := 1;
  SystemParametersInfo(SPI_SETSNAPTODEFBUTTON, iSnap, nil, ss);
end;

procedure THIMouseParams._work_doSetVanish;
var iStat, ss:integer;
begin
  ss := ReadInteger(_Data, _data_SaveSettings, _prop_SaveSettings);
  if ss <> 0 then ss:= SPIF_UPDATEINIFILE or SPIF_SENDCHANGE;
  iStat := ReadInteger(_Data, _data_MouseVanish, _prop_MouseVanish);
  //if iStat <> 0 then iStat := 1;
  SystemParametersInfo(SPI_SETMOUSEVANISH, 0, Pointer(iStat), ss);
end;


procedure THIMouseParams._work_doSwapButtons;
var iSwap, ss:integer;
begin
  ss := ReadInteger(_Data, _data_SaveSettings, _prop_SaveSettings);
  if ss <> 0 then ss:= SPIF_UPDATEINIFILE or SPIF_SENDCHANGE;
  iSwap := ReadInteger(_Data, _data_SwapButtons, _prop_SwapButtons);
  //if iSwap <> 0 then iSwap := 1;
  SystemParametersInfo(SPI_SETMOUSEBUTTONSWAP, iSwap, nil, ss);
end;


procedure THIMouseParams._var_CurSpeed;
var iSpeed:integer;
begin
  SystemParametersInfo(SPI_GETMOUSESPEED, 0, @iSpeed, 0);
  dtInteger(_Data, iSpeed); 
end;

procedure THIMouseParams._var_CurDblClickSpeed;
begin
  dtInteger(_Data, GetDoubleClickTime);
end;

procedure THIMouseParams._var_CurMouseTrails;
var iTrails:integer;
begin
  SystemParametersInfo(SPI_GETMOUSETRAILS, 0, @iTrails, 0);
  dtInteger(_Data, iTrails);
end;

procedure THIMouseParams._var_SonarStatus;
var iStat:integer;
begin
  SystemParametersInfo(SPI_GETMOUSESONAR, 0, @iStat, 0);
  dtInteger(_Data, iStat);
end;

procedure THIMouseParams._var_CurWheelScrollChars;
var iCount:integer;
begin
  SystemParametersInfo(SPI_GETWHEELSCROLLCHARS, 0, @iCount, 0);
  dtInteger(_Data, iCount);
end;

procedure THIMouseParams._var_CurWheelScrollLines;
var iCount:integer;
begin
  SystemParametersInfo(SPI_GETWHEELSCROLLLINES, 0, @iCount, 0);
  dtInteger(_Data, iCount);
end;

procedure THIMouseParams._var_IsSnapToDefButton;
var iSnap:integer;
begin
  SystemParametersInfo(SPI_GETSNAPTODEFBUTTON, 0, @iSnap, 0);
  dtInteger(_Data, iSnap);
end;

procedure THIMouseParams._var_VanishStatus;
var iStat:integer;
begin
  SystemParametersInfo(SPI_GETMOUSEVANISH, 0, @iStat, 0);
  dtInteger(_Data, iStat);
end;

procedure THIMouseParams._var_CurThreshold1;
var iaMouse: array[0..2] of integer;
begin
  SystemParametersInfo(SPI_GETMOUSE, 0, @iaMouse, 0);
  dtInteger(_Data, iaMouse[0]);
end;

procedure THIMouseParams._var_CurThreshold2;
var iaMouse: array[0..2] of integer;
begin
  SystemParametersInfo(SPI_GETMOUSE, 0, @iaMouse, 0);
  dtInteger(_Data, iaMouse[1]);
end;

procedure THIMouseParams._var_CurAcceleration;
var iaMouse: array[0..2] of integer;
begin
  SystemParametersInfo(SPI_GETMOUSE, 0, @iaMouse, 0);
  dtInteger(_Data, iaMouse[2]);
end;

procedure THIMouseParams._var_IsButtonSwapped;
begin
  dtInteger(_Data, GetSystemMetrics(SM_SWAPBUTTON));
end;

procedure THIMouseParams._var_IsMousePresent;
begin
  dtInteger(_Data, GetSystemMetrics(SM_MOUSEPRESENT));
end;

procedure THIMouseParams._var_IsWheelPresent;
begin
  dtInteger(_Data, GetSystemMetrics(SM_MOUSEWHEELPRESENT));
end;

procedure THIMouseParams._var_IsHorizWheelPresent;
begin
  dtInteger(_Data, GetSystemMetrics(SM_MOUSEHORIZONTALWHEELPRESENT));
end;

procedure THIMouseParams._var_ButtonsCount;
begin
  dtInteger(_Data, GetSystemMetrics(SM_CMOUSEBUTTONS));
end;

end.